public class Card {
  /**/
  public static final String EMPTY = "    ";
  public static final String DOWN  = "   x";
  /**/
  private static final String [] VALUE = new String [] {
    "a" , "2" , "3"  , "4" , "5" , "6" , "7" ,
    "8" , "9" , "10" , "j" , "q" , "k"
  };
  /**/
  private static final String [] SUIT = new String [] {
    "cb" , "dr" , "hr" , "sb"
  };
  /**/
  private String designation;
  /*
   *          A           J  Q  K
   *  value = 1 2 ... 10 11 12 13
   *
   *   suit = 0 1 2 3
   *          C D H S
   */
  public Card ( int value, int suit ) {
    designation = VALUE[value-1] + SUIT[suit];
  }
  /**/
  public Card ( String designation ) {
    this.designation=designation;
  }
  /**/
  public String getDesignation () {
    return designation;
  }
  /**/
  public int getValue () {
    /**/
    int len, index;
    String valueS;
    /**/
    len=designation.length();
    if ( len == 4 ) valueS="10";
    else            valueS=designation.substring(0,1);
    /**/
    index=-1;
    for ( int i=0; i<13; ++i ) {
      if ( VALUE[i].equals(valueS) ) {
        index=i;
        break;
      }
    }
    /**/
    return index+1;
  }
  /**/
  public int getSuit () {
    /**/
    int len, index;
    String suitS;
    /**/
    len=designation.length();
    suitS=designation.substring(len-2,len);
    /**/
    index=-1;
    for ( int i=0; i<4; ++i ) {
      if ( SUIT[i].equals(suitS) ) {
        index=i;
        break;
      }
    }
    /**/
    return index;
  }
  /**/
  public boolean equals ( Card o ) {
    /**/
    if ( o.getDesignation().equals(designation) ) return true;
    else                                          return false;
  }
  /**/
  public String toString () {
    return designation;
  }
  /**/
  public boolean isBlack () {
    /**/
    int suit;
    /**/
    suit=getSuit();
    if ( ( suit == 0 ) || ( suit == 3 ) ) return true;
    else                                  return false;
  }
  /**/
  public boolean isRed () {
    /**/
    int suit;
    /**/
    suit=getSuit();
    if ( ( suit == 1 ) || ( suit == 2 ) ) return true;
    else                                  return false;
  }
  /**/
  public static boolean areDifferentColors ( Card c1, Card c2 ) {
    if      ( c1.isRed() && c2.isBlack() ) return true;
    else if ( c1.isBlack() && c2.isRed() ) return true;
    else                                   return false;
  }
  /**/
  public static boolean isValidValueString ( String s ) {
    /**/
    for ( int i=0; i<13; ++i ) {
      if ( VALUE[i].equals(s) ) return true;
    }
    return false;
  }
  /**/
  public static int getValueFromString ( String s ) {
    /**/
    for ( int i=0; i<13; ++i ) {
      if ( VALUE[i].equals(s) ) return i+1;
    }
    return 0;
  }
}
