import java.util.ArrayList;
/**/
public class CardRow {
  /**/
  private ArrayList<Card> downList, upList;
  /**/
  public CardRow ( Card [] ca ) {
    /**/
    int len;
    /**/
    downList=new ArrayList<Card> ();
    upList=new ArrayList<Card> ();
    /**/
    len=ca.length;
    for ( int i=0; i<len-1; ++i ) downList.add(ca[i]);
    upList.add(ca[len-1]);
  }
  /**/
  public boolean isEmpty () {
    if ( ( downList.size() == 0 ) && ( upList.size() == 0 ) ) return true;
    else                                                      return false;
  }
  /**/
  public ArrayList<Card> remove ( Card c ) {
    /**/
    int size, index, returnSize, downListLast;
    Card temp;
    ArrayList<Card> rv;
    /**/
    if ( isEmpty() )           return null;
    if ( !contains(upList,c) ) return null;
    /**/
    size=upList.size();
    index=indexOf(upList,c);
    returnSize=size-index;
    /**/
    rv=new ArrayList<Card> ();
    for ( int i=0; i<returnSize; ++i ) rv.add(upList.remove(index));
    /**/
    if ( upList.size() == 0 ) {
      if ( !isEmpty() ) {
        downListLast=downList.size()-1;
        temp=downList.remove(downListLast);
        upList.add(temp);
      }
    }
    /**/
    return rv;
  }
  /**/
  public boolean canAdd ( Card c ) {
    /**/
    int value, bottomValue, diff;
    Card bottomCard;
    /**/
    value=c.getValue();
    /**/
    if ( isEmpty() ) {
      if ( value == 13 ) return true;
      else               return false;
    }
    if ( value == 1 ) return false;
    /**/
    bottomCard=getBottomCard();
    bottomValue=bottomCard.getValue();
    if ( bottomValue == 2 ) return false;
    diff=bottomValue-value;
    if ( diff == 1 ) {
      if ( Card.areDifferentColors(c,bottomCard) ) return true;
      else                                         return false;
    }
    else {
      return false;
    }
  }
  /**/
  public void add ( Card c ) {
    upList.add(c);
  }
  /**/
  public void add ( ArrayList<Card> cardList ) {
    /**/
    int addSize;
    /**/
    addSize=cardList.size();
    for ( int i=0; i<addSize; ++i ) upList.add(cardList.get(i));
    /**/
    return;
  }
  /**/
  public Card getBottomCard () {
    /**/
    int lastCard;
    /**/
    if ( isEmpty() ) return null;
    /**/
    lastCard=upList.size()-1;
    return upList.get(lastCard);
  }
  /**/
  public int getReturnListSize ( Card c ) {
    /**/
    int len, index;
    /**/
    len=upList.size();
    index=indexOf(upList,c);
    /**/
    return len-index;
  }
  /**/
  public Card getCardFromValue ( int value ) {
    /**/
    int v;
    Card c;
    /**/
    for ( int i=0; i<upList.size(); ++i ) {
      c=upList.get(i);
      v=c.getValue();
      if ( v == value ) return c;
    }
    return null;
  }
  /**/
  public boolean hasNoDown () {
    if ( downList.size() == 0 ) return true;
    else                        return false;
  }
  /**/
  public String toString () {
    /**/
    int downSize, upSize;
    String rv;
    /**/
    rv="";
    /**/
    if ( !isEmpty() ) {
      downSize=downList.size();
      upSize=upList.size();
      for ( int i=0; i<downSize; ++i ) rv += ( Card.DOWN + " " );
      for ( int i=0; i<upSize;   ++i ) rv += ( String.format("%4s",upList.get(i).toString()) + " " );
    }
    /**/
    return rv;
  }
  /**/
  private static boolean contains ( ArrayList<Card> cardList, Card card ) {
    /**/
    int len;
    /**/
    len=cardList.size();
    for ( int i=0; i<len; ++i ) {
      if ( cardList.get(i).equals(card) ) return true;
    }
    return false;
  }
  /**/
  private static int indexOf ( ArrayList<Card> cardList, Card card ) {
    /**/
    int len;
    /**/
    len=cardList.size();
    for ( int i=0; i<len; ++i ) {
      if ( cardList.get(i).equals(card) ) return i;
    }
    return -1;
  }
}
