public class CardRows {
  /**/
  private CardRow [] rows;
  /**/
  public CardRows ( Deck deck ) {
    /**/
    init(deck);
  }
  /**/
  public CardRow [] getCardRows () {
    return rows;
  }
  /**/
  public boolean haveNoDown () {
    /**/
    for ( int i=0; i<7; ++i ) {
      if ( !rows[i].hasNoDown() ) return false;
    }
    return true;
  }
  /**/
  public String toString () {
    /**/
    String lf, line, rv;
    /**/
    lf=System.lineSeparator();
    rv = "row decks" + lf + lf;
    for ( int i=0; i<7; ++i ) {
      line = Integer.toString(i) + " ";
      line += rows[i].toString();
      if ( i != 6 ) line += lf;
      rv += line;
    }
    /**/
    return rv;
  }
  /**/
  private void init ( Deck d ) {
    /**/
    Card [][] cda;
    /**/
    cda=new Card [7][];
    for ( int i=0; i<7; ++i ) cda[i]=new Card [i+1];
    /**/
    for ( int j=0; j<7; ++j ) {
      for ( int i=j; i<7; ++i ) cda[i][j]=d.deal();
    }
    /**/
    rows=new CardRow [7];
    for ( int i=0; i<7; ++i ) rows[i]=new CardRow(cda[i]);
    /**/
    return;
  }
}
